<?php
/*
 * Start session ---------------------------------------------------------------
 */
@session_start();

################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
/**
 * Installer -------------------------------------------------------------------
 */
if( file_exists('installer/index.php') ){
    header("Location: installer/");
    exit;
}

/*
 * Include required files ------------------------------------------------------
 */
require_once 'config.php';
require_once BASE_CLASS . 'class-security.php';
require_once BASE_CLASS . 'class-log.php';
require_once BASE_CLASS . 'class-connect.php';
require_once BASE_CLASS . 'class-setting.php';
require_once BASE_CLASS . 'class-page.php';
require_once BASE_CLASS . 'class-prettyphoto.php';
require_once BASE_CLASS . 'class-menu-manager.php';
require_once BASE_CLASS . 'class-form-feedback.php';

/*
 * Define constants ------------------------------------------------------------
 */
$_SETTING = new Setting();
if( !defined('DEFAULT_HOME_SLUG') )
{
    define('DEFAULT_HOME_SLUG', $_SETTING->getHomeSlug());
    define('FRAMEWORK_NAME', $_SETTING->getFrameworkName());
    define('ADMIN_CONTACT_EMAIL',$_SETTING->getAdminEmail());
    define('ADMIN_PASSWORD', $_SETTING->getAdminPassword());
}

/*
 * Load settings ---------------------------------------------------------------
 */
$_SECURITY = new Security();
$_PAGE = new Page($_SECURITY->getUserGroup(),$_SETTING->getThemeDir());
$_PRETTYPHOTO = new PrettyPhotoManager();
$_MENU = new MenuManager($_SECURITY->getUserGroup());

/*
 * Load page language ----------------------------------------------------------
 */
$pl = $_PAGE->getPageLanguageURL();
$_LOCAL = array();

if( !empty($pl) )
{
    require_once $pl;
    
    $_LOCAL = $_LANG;
}

/*
 * Load global language file ---------------------------------------------------
 */
$gl = $_PAGE->getGlobalLanguageURL();
if(file_exists($gl) )
{
    require_once $gl;
    
    $_GLANG = $_GLOB;
}

/*
 * Load controller -------------------------------------------------------------
 */
$cu = $_PAGE->getControllerURL();

if( !empty($cu) )
{
    $cn = $_PAGE->getControllerClassname();
    
    require_once $cu;
    
    $_CLASS = new $cn($_LOCAL);
}

/*
 * Define page title: if the destination page is the vehicle's page, override
 * default page title and set it as the vehicle maker, model, type and year.
 */
$pt = ucfirst($_PAGE->getPageSlug());
$pt = str_replace('-',' ',$pt);
$_PAGE_TITLE = FRAMEWORK_NAME . ': ' . $pt;

if( $_PAGE->getPageSlug() == 'car-detail' ){
    $uri = explode('/', $_SERVER['REQUEST_URI']);
    $target_index = 0;
    
    for( $i=0; $i < count($uri); $i++ ){
        if( $uri[$i] == $_PAGE->getPageSlug() ){
            $target_index = $i - 1;
            break;
        }
    }
    
    $_PAGE_TITLE = str_replace('-',' ',$uri[$target_index]);
    $_PAGE_TITLE = strtoupper($_PAGE_TITLE);
}

/*
 * Initialize XHTML output -----------------------------------------------------
 */
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\r\n";
echo '<html xmlns="http://www.w3.org/1999/xhtml" lang="'.$_SETTING->getLanguageISO().'">' . "\r\n";
echo '<!--' . "\r\n";
echo '### This disclaimer must be kept in order to use this product. ###' . "\r\n";
echo '### Project: jT CarFramework [http://intersofts.com]' . "\r\n";
echo '### Author: J. Toshio Taniguchi' . "\r\n";
echo '### Since: 27.04.2011' . "\r\n";
echo '### Version: 1.4.9' . "\r\n";
echo '### Copyrights: J. Toshio Taniguchi' . "\r\n";
echo '### Contact: j.taniguchi@taniguchi-blog.com' . "\r\n";
echo '### This disclaimer must be kept in order to use this product. ###' . "\r\n";
echo '-->' . "\r\n";
echo '  <head>' . "\r\n";
echo '    <title>'.$_PAGE_TITLE.'</title>' . "\r\n";
echo '    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />' . "\r\n";
echo '    <meta name="keywords" content="'.$_PAGE->getMetaKeywords().'" />' . "\r\n";
echo '    <meta name="description" content="'.$_PAGE->getMetaDescription().'" />' . "\r\n";
echo '    <meta name="language" content="'.$_SETTING->getDefaultLanguage().'" />' . "\r\n";
echo '    <meta name="robots" content="'.$_PAGE->getMetaRobots().',NOODP" />' . "\r\n";
echo '    <meta name="author" content="'.$_PAGE->getPageAuthor().'" />' . "\r\n";
echo '    <meta name="copyright" content="'.$_SETTING->getMetaCopyrights().'" />' . "\r\n";
echo '    <meta name="publisher" content="'.$_SETTING->getMetaCopyrights().'" />' . "\r\n";
echo '    <meta name="revisit-After" content="1 days" />' . "\r\n";
echo '    <meta name="distribution" content="global" />' . "\r\n";
echo '    <link rel="canonical" href="'.$_SETTING->getMetaCanonic().'" />' . "\r\n";
echo '    <link rel="shortcut icon" href="'.$_SETTING->getFaviconURL().'" type="image/x-icon" />' . "\r\n";

// load jQuery.
echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/jquery/jquery.js"></script>' . "\r\n";

// load Bootstrap.
echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/bootstrap/js/bootstrap.min.js"></script>' . "\r\n";
echo '    <link href="'.BASE_RELATIVE.'view/3rdparty/bootstrap/css/bootstrap.css" rel="stylesheet" type="text/css" />' . "\r\n";
echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/bootstrap/js/bootbox.js"></script>' . "\r\n";

// load prettyPhoto.
echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/prettyphoto/jquery.prettyPhoto.js"></script>' . "\r\n";
echo '    <link href="'.BASE_RELATIVE.'view/3rdparty/prettyphoto/prettyPhoto.css" rel="stylesheet" type="text/css" />' . "\r\n";

// load CKEditor.
if( $_PAGE->getPageGroup() != 'public' ){
    echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/ckeditor/ckeditor.js"></script>' . "\r\n";
    echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/ckeditor/adapters/jquery.js"></script>' . "\r\n";
    echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/ckfinder/ckfinder.js"></script>' . "\r\n";
}

// load Nivo Slider if page is the default home and public.
if( $_PAGE->getPageSlug() == DEFAULT_HOME_SLUG && $_PAGE->getPageGroup() == 'public' )
{
    if( $_SETTING->getBannerHeaderStatus() )
    {
        echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/nivo/jquery.nivo.slider.pack.js"></script>' . "\r\n";
        echo '    <link href="'.BASE_RELATIVE.'view/3rdparty/nivo/nivo-slider.css" rel="stylesheet" type="text/css" />' . "\r\n";
        echo '    <link href="'.BASE_RELATIVE.'view/3rdparty/nivo/themes/default/default.css" rel="stylesheet" type="text/css" />' . "\r\n";
    }
}

// load jquery UI just for advanced search page. You can ad support to more pages
// by implementing the switch below:
switch ($_PAGE->getPageSlug()){
    case 'advanced-search':
        echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/3rdparty/jquery-ui/jquery-ui-1.10.3.custom.min.js"></script>' . "\r\n";
        echo '    <link href="'.BASE_RELATIVE.'view/3rdparty/jquery-ui/jquery-ui-1.10.3.custom.min.css" rel="stylesheet" type="text/css" />' . "\r\n";
        break;
}


// load global JS + CSS.
echo '    <script type="text/javascript" language="javascript" src="'.BASE_RELATIVE.'view/theme/'.$_SETTING->getThemeDir().'/js/global.js"></script>' . "\r\n";
echo '    <link href="'.BASE_RELATIVE.'view/theme/'.$_SETTING->getThemeDir().'/css/global.css" rel="stylesheet" type="text/css" />' . "\r\n";

// load IEHacks.
echo '    <!-- [if IE]><link href="'.BASE_RELATIVE.'view/theme/'.$_SETTING->getThemeDir().'/css/ie.css" rel="stylesheet" type="text/css" /><!--<![endif]-->' . "\r\n";
echo '    <link href="'.BASE_RELATIVE.'view/theme/'.$_SETTING->getThemeDir().'/css/firefox.css" rel="stylesheet" type="text/css" />' . "\r\n";
echo '    <link href="'.BASE_RELATIVE.'view/theme/'.$_SETTING->getThemeDir().'/css/safari.css" rel="stylesheet" type="text/css" />' . "\r\n";

// load dynamic CSS + JS
$css = $_PAGE->getCSSURL();
$js = $_PAGE->getJSURL();

if( !empty($css) )
{
    echo '    <link href="'.$css.'" rel="stylesheet" type="text/css" />' . "\r\n";
}

if( !empty($js) )
{
    echo '    <script type="text/javascript" language="javascript" src="'.$js.'"></script>' . "\r\n";
}

// google font.
echo '      <link href="http://fonts.googleapis.com/css?family=Ubuntu:300,400,500,700,400italic,700italic|Shadows+Into+Light" rel="stylesheet" type="text/css">' . "\r\n";

// display analytics.
echo $_SETTING->getAnalytics();

echo '  </head>' . "\r\n";
echo '  <body>' . "\r\n";

// initialize container wrapper.
echo '    <div id="container">' . "\r\n";

// HEADER TOP ------------------------------------------------------------------
if( $_SETTING->getTopHeaderStatus() )
{
    $th = $_PAGE->getTopHeaderURL();

    if( !empty($th) )
    {
        require_once $th;
    }
}

// HEADER MENU -----------------------------------------------------------------
if( $_SETTING->getMenuHeaderStatus() )
{
    $mh = $_PAGE->getMenuHeaderURL();

    if( !empty($mh) )
    {
        require_once $mh;
    }
}

// HEADER BANNER ---------------------------------------------------------------
if( $_SETTING->getBannerHeaderStatus() )
{
    require_once BASE_CLASS . 'class-nivoslider.php';
    
    $_NIVO_SLIDER = new NivoSliderManager();
    
    $bh = $_PAGE->getBannerHeaderURL();

    if( !empty($bh) )
    {
        require_once $bh;
    }
}

// CONTENT ---------------------------------------------------------------------
$p_content = $_PAGE->getContentURL();

if( file_exists($p_content) ){
    require_once $p_content;
} else {
    echo 'Error: Unable to load page content due an internal error. Page requested does not exists and no default 404 is set.';
}

// HEADER FOOT -----------------------------------------------------------------
if( $_SETTING->getFootHeaderStatus() )
{
    $fh = $_PAGE->getFootHeaderURL();

    if( !empty($fh) )
    {
        require_once $fh;
    }
}

// live chat float box.
if( $_SETTING->getLiveChatStatus() ){
    echo '    <div id="liveChatWrapper">' . "\r\n";
    echo '        <a href="' . BASE_RELATIVE . 'webim/client.php?locale=en" target="_blank" onclick="if(navigator.userAgent.toLowerCase().indexOf(\'opera\') != -1 && window.event.preventDefault) window.event.preventDefault();this.newWindow = window.open(\''.BASE_RELATIVE.'webim/client.php?locale='. $_SESSION['log_language_iso'] .'\', \'webim\', \'toolbar=0,scrollbars=0,location=0,status=1,menubar=0,width=640,height=480,resizable=1\');this.newWindow.focus();this.newWindow.opener=window;return false;"></a></div>' . "\r\n";
    echo '    </div>' . "\r\n";
}

// end container wrapper.
echo '    </div>' . "\r\n";

// initialize PrettyPhoto module.
echo '    <script type="text/javascript" language="javascript" charset="utf-8">' . "\r\n";
echo '    	$(document).ready(function(){' . "\r\n";
echo '    		$("a[rel^=\'prettyPhoto\']").prettyPhoto({' . "\r\n";
echo '    			animation_speed: \''.$_PRETTYPHOTO->getAnimationSpeed().'\',' . "\r\n";
echo '    			slideshow: '.$_PRETTYPHOTO->getSlideShow().',' . "\r\n";
echo '    			autoplay_slideshow: '.$_PRETTYPHOTO->getAutoPlaySlideShow().',' . "\r\n";
echo '    			opacity: '.$_PRETTYPHOTO->getOpacity().',' . "\r\n";
echo '    			show_title: '.$_PRETTYPHOTO->getShowTitle().',' . "\r\n";
echo '    			allow_resize: '.$_PRETTYPHOTO->getAllowResize().',' . "\r\n";
echo '    			default_width: '.$_PRETTYPHOTO->getDefaultWidth().',' . "\r\n";
echo '    			default_height: '.$_PRETTYPHOTO->getDefaultHeight().',' . "\r\n";
echo '    			counter_separator_label: \''.$_PRETTYPHOTO->getCounterSeparator().'\',' . "\r\n";
echo '    			theme: \''.$_PRETTYPHOTO->getThemeName().'\',' . "\r\n";
echo '    			horizontal_padding: '.$_PRETTYPHOTO->getHorizontalPadding().',' . "\r\n";
echo '    			hideflash: '.$_PRETTYPHOTO->getHideFlash().',' . "\r\n";
echo '    			wmode: \''.$_PRETTYPHOTO->getWMode().'\',' . "\r\n";
echo '    			autoplay: '.$_PRETTYPHOTO->getAutoPlaySlideShow().',' . "\r\n";
echo '    			modal: '.$_PRETTYPHOTO->getModal().',' . "\r\n";
echo '    			deeplinking: '.$_PRETTYPHOTO->getDeeplinking().',' . "\r\n";
echo '    			overlay_gallery: '.$_PRETTYPHOTO->getOverlayGallery().',' . "\r\n";
echo '    			keyboard_shortcuts: '.$_PRETTYPHOTO->getKeyboardShortcut().',' . "\r\n";
echo '    			social_tools: false' . "\r\n";
echo '    		});' . "\r\n";
echo '    	});' . "\r\n";

// initialize nivo slider if page is public and default home.
if( $_PAGE->getPageSlug() == DEFAULT_HOME_SLUG && $_PAGE->getPageGroup() == 'public' && $_SETTING->getBannerHeaderStatus() )
{
    if( !empty($_NIVO_SLIDER) )
    {
        if( $_NIVO_SLIDER->getNivoStatus() )
        {
            echo '    	$(window).load(function() {'. "\r\n";
            echo '    		$(\'#slider\').nivoSlider({'. "\r\n";
            echo '    			animSpeed: '.$_NIVO_SLIDER->getAnimationSpeed().','. "\r\n";
            echo '                      pauseTime: '.$_NIVO_SLIDER->getPauseTime().','. "\r\n";
            echo '                      directionNav: '.$_NIVO_SLIDER->getDirectionNavigation().','. "\r\n";
            echo '                      controlNav: '.$_NIVO_SLIDER->getControlNavigationBullets().','. "\r\n";
            echo '                      controlNavThumbs: '.$_NIVO_SLIDER->getControlNavigationThumb().','. "\r\n";
            echo '                      pauseOnHover: '.$_NIVO_SLIDER->getPauseOnMouseOver().','. "\r\n";
            echo '                      manualAdvance: '.$_NIVO_SLIDER->getManualAdvance().','. "\r\n";
            echo '                      prevText: \''.$_NIVO_SLIDER->getPrevText().'\','. "\r\n";
            echo '                      nextText: \''.$_NIVO_SLIDER->getNextText().'\','. "\r\n";
            echo '                      randomStart: '.$_NIVO_SLIDER->getRandomStart().''. "\r\n";
            echo '              });'. "\r\n";
            echo '        });'. "\r\n";
        }
    }
}

// initialize CKEditor module depending on page's status.
if( $_CKEDITOR_ENABLED )
{
    if( !empty($_CKEDITOR_ID) )
    {
        echo '    $(document).ready(function(){' . "\r\n";
        echo '        CKEDITOR.replace(\''.$_CKEDITOR_ID.'\',{
                                        "filebrowserBrowseUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/ckfinder.html",
                                        "filebrowserImageBrowseUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/ckfinder.html?type=Images",
                                        "filebrowserFlashBrowseUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/ckfinder.html?type=Flash",
                                        "filebrowserUploadUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Files",
                                        "filebrowserImageUploadUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Images",
                                        "filebrowserFlashUploadUrl":"'.BASE_RELATIVE.'view/3rdparty/ckfinder/core/connector/php/connector.php?command=QuickUpload&type=Flash"});' . "\r\n";
        echo '    });' . "\r\n";
    }
}


echo '    </script>' . "\r\n";
echo '  </body>' . "\r\n";
echo '</html>' . "\r\n";
